<template src="./template.html"></template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import axios from "axios";
import { apiErrorHandler } from "~/utils/apiHanlers";
@Component({
  components: {},
})
export default class CartComponent extends Vue {
  listCart: any = [];
  listCartClone: any = [];
  listShipping = [];
  loadingTable = false;
  findGreatThanShipping = {};
  tip = 0;

  mounted() {
    //@ts-ignore
    // const cart = JSON.parse(localStorage.getItem("cart"));
    // if (cart && cart.length) {
    //   this.listCart = cart;
    //   this.listCartClone = this.$utils.cloneDeep(this.listCart);
    // }
    // //@ts-ignore
    // this.tip = JSON.parse(localStorage.getItem("tip")) || 0;
    // this.onGetListShipping();
  }

  countryCodePayment = "";
  nameShipping = "";
  async onGetListShipping(country?: string) {
    try {
      this.loadingTable = true;
      this.countryCodePayment = country || this.myIp.countryCode || "";
      const domain = this.$store.state?.product?.domain || "";
      const response = await this.$api.shipping.listShipping(
        domain,
        this.countryCodePayment,
        this.siteInfo.adminId
      );
      if (response?.data?.length) {
        this.listShipping = response.data;
        this.calcShipPrice();
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  onDecrease(i: number) {
    if (this.listCart[i].quantity <= 1) return;
    this.listCart[i].quantity -= 1;
  }

  onIncrease(i: number) {
    this.listCart[i].quantity += 1;
  }

  onUpdateListCart() {
    this.listCartClone = this.$utils.cloneDeep(this.listCart);
    localStorage.setItem("cart", JSON.stringify(this.listCart));
    localStorage.setItem("isCart", JSON.stringify(true));
    this.calcShipPrice();
  }

  onRemove(i: number) {
    this.listCart.splice(i, 1);
  }

  formatCurrency(currency: number) {
    return this.$utils.formatCurrencyFloat(
      (Math.round(currency * 100) / 100).toFixed(2)
    );
  }

  calcShipPrice() {
    if (this.listCart && this.listCart.length) {
      let total = 0;
      //@ts-ignore
      let totalPrice = Math.round(this.totalPrice * 100) / 100;
      for (let product of this.listCart) {
        total += product.quantity;
      }

      let listShippingFilter: any = this.listShipping.filter(
        (shipping: any) =>
          shipping.quantity <= total || shipping.total <= totalPrice
      );
      listShippingFilter.sort((a: any, b: any) => {
        return a.price - b.price;
      });
      if (listShippingFilter.length) {
        this.nameShipping = listShippingFilter[0]?.name || "Shipping";
        for (let shipping of listShippingFilter) {
          if (shipping.quantity) {
            this.findGreatThanShipping = shipping;
          }
          if (shipping.total) {
            this.findGreatThanShipping = shipping;
          }
        }
      }
    }
  }

  get siteInfo() {
    return this.$store.state.setting.siteInfo;
  }

  get myIp() {
    return this.$store.state.sitePage.myIp || {};
  }

  get isChanged() {
    return this.$utils.compare(this.listCart, this.listCartClone);
  }

  get totalPrice() {
    let total = 0;
    for (let cart of this.listCart) {
      total += cart.quantity * cart.price;
    }
    return this.formatCurrency(total) || 0;
  }
}
</script>

<style lang="css">
#cart,
#cart table {
  background-color: #f7f7f7;
}
#cart .content {
  max-width: 1180px;
}

#cart .content .text-title {
  font-size: 35px !important;
}

#cart .content .btn-quantity {
  border-radius: 4px;
  border: 1px solid #e3e3e3;
  background: #fff;
}

#cart .content .btn-quantity div {
  width: 32px;
  height: 32px;
}
</style>
